Index: IMGUI/imgui_demo.cpp
===================================================================
--- IMGUI/imgui_demo.cpp	(revision c58ebc3899e898504313cf42b9c1c05170b13f8f)
+++ IMGUI/imgui_demo.cpp	(revision 670c09af1971c9568423ac0b125725b93b7fb2f7)
@@ -83,213 +149,364 @@
 static void ShowExampleAppAutoResize(bool* p_open);
 static void ShowExampleAppConstrainedResize(bool* p_open);
-static void ShowExampleAppFixedOverlay(bool* p_open);
+static void ShowExampleAppSimpleOverlay(bool* p_open);
 static void ShowExampleAppWindowTitles(bool* p_open);
 static void ShowExampleAppCustomRendering(bool* p_open);
-static void ShowExampleAppMainMenuBar();
 static void ShowExampleMenuFile();
 
-static void ShowHelpMarker(const char* desc)
+// Helper to display a little (?) mark which shows a tooltip when hovered.
+// In your own code you may want to display an actual icon if you are using a merged icon fonts (see docs/FONTS.md)
+static void HelpMarker(const char* desc)
 {
-   ImGui::TextDisabled("(?)");
-   if (ImGui::IsItemHovered())
-   {
-      ImGui::BeginTooltip();
-      ImGui::PushTextWrapPos(ImGui::GetFontSize() * 35.0f);
-      ImGui::TextUnformatted(desc);
-      ImGui::PopTextWrapPos();
-      ImGui::EndTooltip();
-   }
+    ImGui::TextDisabled("(?)");
+    if (ImGui::IsItemHovered())
+    {
+        ImGui::BeginTooltip();
+        ImGui::PushTextWrapPos(ImGui::GetFontSize() * 35.0f);
+        ImGui::TextUnformatted(desc);
+        ImGui::PopTextWrapPos();
+        ImGui::EndTooltip();
+    }
 }
 
+// Helper to display basic user controls.
 void ImGui::ShowUserGuide()
 {
-   ImGui::BulletText("Double-click on title bar to collapse window.");
-   ImGui::BulletText("Click and drag on lower right corner to resize window\n(double-click to auto fit window to its contents).");
-   ImGui::BulletText("Click and drag on any empty space to move window.");
-   ImGui::BulletText("TAB/SHIFT+TAB to cycle through keyboard editable fields.");
-   ImGui::BulletText("CTRL+Click on a slider or drag box to input value as text.");
-   if (ImGui::GetIO().FontAllowUserScaling)
-      ImGui::BulletText("CTRL+Mouse Wheel to zoom window contents.");
-   ImGui::BulletText("Mouse Wheel to scroll.");
-   ImGui::BulletText("While editing text:\n");
-   ImGui::Indent();
-   ImGui::BulletText("Hold SHIFT or use mouse to select text.");
-   ImGui::BulletText("CTRL+Left/Right to word jump.");
-   ImGui::BulletText("CTRL+A or double-click to select all.");
-   ImGui::BulletText("CTRL+X,CTRL+C,CTRL+V to use clipboard.");
-   ImGui::BulletText("CTRL+Z,CTRL+Y to undo/redo.");
-   ImGui::BulletText("ESCAPE to revert.");
-   ImGui::BulletText("You can apply arithmetic operators +,*,/ on numerical values.\nUse +- to subtract.");
-   ImGui::Unindent();
+    ImGuiIO& io = ImGui::GetIO();
+    ImGui::BulletText("Double-click on title bar to collapse window.");
+    ImGui::BulletText(
+        "Click and drag on lower corner to resize window\n"
+        "(double-click to auto fit window to its contents).");
+    ImGui::BulletText("CTRL+Click on a slider or drag box to input value as text.");
+    ImGui::BulletText("TAB/SHIFT+TAB to cycle through keyboard editable fields.");
+    if (io.FontAllowUserScaling)
+        ImGui::BulletText("CTRL+Mouse Wheel to zoom window contents.");
+    ImGui::BulletText("While inputing text:\n");
+    ImGui::Indent();
+    ImGui::BulletText("CTRL+Left/Right to word jump.");
+    ImGui::BulletText("CTRL+A or double-click to select all.");
+    ImGui::BulletText("CTRL+X/C/V to use clipboard cut/copy/paste.");
+    ImGui::BulletText("CTRL+Z,CTRL+Y to undo/redo.");
+    ImGui::BulletText("ESCAPE to revert.");
+    ImGui::BulletText("You can apply arithmetic operators +,*,/ on numerical values.\nUse +- to subtract.");
+    ImGui::Unindent();
+    ImGui::BulletText("With keyboard navigation enabled:");
+    ImGui::Indent();
+    ImGui::BulletText("Arrow keys to navigate.");
+    ImGui::BulletText("Space to activate a widget.");
+    ImGui::BulletText("Return to input text into a widget.");
+    ImGui::BulletText("Escape to deactivate a widget, close popup, exit child window.");
+    ImGui::BulletText("Alt to jump to the menu layer of a window.");
+    ImGui::BulletText("CTRL+Tab to select a window.");
+    ImGui::Unindent();
 }
 
-// Demonstrate most ImGui features (big function!)
+//-----------------------------------------------------------------------------
+// [SECTION] Demo Window / ShowDemoWindow()
+//-----------------------------------------------------------------------------
+// - ShowDemoWindowWidgets()
+// - ShowDemoWindowLayout()
+// - ShowDemoWindowPopups()
+// - ShowDemoWindowColumns()
+// - ShowDemoWindowMisc()
+//-----------------------------------------------------------------------------
+
+// We split the contents of the big ShowDemoWindow() function into smaller functions
+// (because the link time of very large functions grow non-linearly)
+static void ShowDemoWindowWidgets();
+static void ShowDemoWindowLayout();
+static void ShowDemoWindowPopups();
+static void ShowDemoWindowColumns();
+static void ShowDemoWindowMisc();
+
+// Demonstrate most Dear ImGui features (this is big function!)
+// You may execute this function to experiment with the UI and understand what it does.
+// You may then search for keywords in the code when you are interested by a specific feature.
 void ImGui::ShowDemoWindow(bool* p_open)
 {
-   // Examples apps
-   static bool show_app_main_menu_bar = false;
-   static bool show_app_console = false;
-   static bool show_app_log = false;
-   static bool show_app_layout = false;
-   static bool show_app_property_editor = false;
-   static bool show_app_long_text = false;
-   static bool show_app_auto_resize = false;
-   static bool show_app_constrained_resize = false;
-   static bool show_app_fixed_overlay = false;
-   static bool show_app_window_titles = false;
-   static bool show_app_custom_rendering = false;
-   static bool show_app_style_editor = false;
-
-   static bool show_app_metrics = false;
-   static bool show_app_about = false;
-
-   if (show_app_main_menu_bar)       ShowExampleAppMainMenuBar();
-   if (show_app_console)             ShowExampleAppConsole(&show_app_console);
-   if (show_app_log)                 ShowExampleAppLog(&show_app_log);
-   if (show_app_layout)              ShowExampleAppLayout(&show_app_layout);
-   if (show_app_property_editor)     ShowExampleAppPropertyEditor(&show_app_property_editor);
-   if (show_app_long_text)           ShowExampleAppLongText(&show_app_long_text);
-   if (show_app_auto_resize)         ShowExampleAppAutoResize(&show_app_auto_resize);
-   if (show_app_constrained_resize)  ShowExampleAppConstrainedResize(&show_app_constrained_resize);
-   if (show_app_fixed_overlay)       ShowExampleAppFixedOverlay(&show_app_fixed_overlay);
-   if (show_app_window_titles)       ShowExampleAppWindowTitles(&show_app_window_titles);
-   if (show_app_custom_rendering)    ShowExampleAppCustomRendering(&show_app_custom_rendering);
-
-   if (show_app_metrics) { ImGui::ShowMetricsWindow(&show_app_metrics); }
-   if (show_app_style_editor) { ImGui::Begin("Style Editor", &show_app_style_editor); ImGui::ShowStyleEditor(); ImGui::End(); }
-   if (show_app_about)
-   {
-      ImGui::Begin("About Dear ImGui", &show_app_about, ImGuiWindowFlags_AlwaysAutoResize);
-      ImGui::Text("Dear ImGui, %s", ImGui::GetVersion());
-      ImGui::Separator();
-      ImGui::Text("By Omar Cornut and all dear imgui contributors.");
-      ImGui::Text("Dear ImGui is licensed under the MIT License, see LICENSE for more information.");
-      ImGui::End();
-   }
-
-   static bool no_titlebar = false;
-   static bool no_scrollbar = false;
-   static bool no_menu = false;
-   static bool no_move = false;
-   static bool no_resize = false;
-   static bool no_collapse = false;
-   static bool no_close = false;
-   static bool no_nav = false;
-
-   // Demonstrate the various window flags. Typically you would just use the default.
-   ImGuiWindowFlags window_flags = 0;
-   if (no_titlebar)  window_flags |= ImGuiWindowFlags_NoTitleBar;
-   if (no_scrollbar) window_flags |= ImGuiWindowFlags_NoScrollbar;
-   if (!no_menu)     window_flags |= ImGuiWindowFlags_MenuBar;
-   if (no_move)      window_flags |= ImGuiWindowFlags_NoMove;
-   if (no_resize)    window_flags |= ImGuiWindowFlags_NoResize;
-   if (no_collapse)  window_flags |= ImGuiWindowFlags_NoCollapse;
-   if (no_nav)       window_flags |= ImGuiWindowFlags_NoNav;
-   if (no_close)     p_open = NULL; // Don't pass our bool* to Begin
-
-   ImGui::SetNextWindowSize(ImVec2(550, 680), ImGuiCond_FirstUseEver);
-   if (!ImGui::Begin("ImGui Demo", p_open, window_flags))
-   {
-      // Early out if the window is collapsed, as an optimization.
-      ImGui::End();
-      return;
-   }
-
-   //ImGui::PushItemWidth(ImGui::GetWindowWidth() * 0.65f);    // 2/3 of the space for widget and 1/3 for labels
-   ImGui::PushItemWidth(-140);                                 // Right align, keep 140 pixels for labels
-
-   ImGui::Text("dear imgui says hello. (%s)", IMGUI_VERSION);
-
-   // Menu
-   if (ImGui::BeginMenuBar())
-   {
-      if (ImGui::BeginMenu("Menu"))
-      {
-         ShowExampleMenuFile();
-         ImGui::EndMenu();
-      }
-      if (ImGui::BeginMenu("Examples"))
-      {
-         ImGui::MenuItem("Main menu bar", NULL, &show_app_main_menu_bar);
-         ImGui::MenuItem("Console", NULL, &show_app_console);
-         ImGui::MenuItem("Log", NULL, &show_app_log);
-         ImGui::MenuItem("Simple layout", NULL, &show_app_layout);
-         ImGui::MenuItem("Property editor", NULL, &show_app_property_editor);
-         ImGui::MenuItem("Long text display", NULL, &show_app_long_text);
-         ImGui::MenuItem("Auto-resizing window", NULL, &show_app_auto_resize);
-         ImGui::MenuItem("Constrained-resizing window", NULL, &show_app_constrained_resize);
-         ImGui::MenuItem("Simple overlay", NULL, &show_app_fixed_overlay);
-         ImGui::MenuItem("Manipulating window titles", NULL, &show_app_window_titles);
-         ImGui::MenuItem("Custom rendering", NULL, &show_app_custom_rendering);
-         ImGui::EndMenu();
-      }
-      if (ImGui::BeginMenu("Help"))
-      {
-         ImGui::MenuItem("Metrics", NULL, &show_app_metrics);
-         ImGui::MenuItem("Style Editor", NULL, &show_app_style_editor);
-         ImGui::MenuItem("About Dear ImGui", NULL, &show_app_about);
-         ImGui::EndMenu();
-      }
-      ImGui::EndMenuBar();
-   }
-
-   ImGui::Spacing();
-   if (ImGui::CollapsingHeader("Help"))
-   {
-      ImGui::TextWrapped("This window is being created by the ShowDemoWindow() function. Please refer to the code in imgui_demo.cpp for reference.\n\n");
-      ImGui::Text("USER GUIDE:");
-      ImGui::ShowUserGuide();
-   }
-
-   if (ImGui::CollapsingHeader("Window options"))
-   {
-      ImGui::Checkbox("No titlebar", &no_titlebar); ImGui::SameLine(150);
-      ImGui::Checkbox("No scrollbar", &no_scrollbar); ImGui::SameLine(300);
-      ImGui::Checkbox("No menu", &no_menu);
-      ImGui::Checkbox("No move", &no_move); ImGui::SameLine(150);
-      ImGui::Checkbox("No resize", &no_resize); ImGui::SameLine(300);
-      ImGui::Checkbox("No collapse", &no_collapse);
-      ImGui::Checkbox("No close", &no_close); ImGui::SameLine(150);
-      ImGui::Checkbox("No nav", &no_nav);
-
-      if (ImGui::TreeNode("Style"))
-      {
-         ImGui::ShowStyleEditor();
-         ImGui::TreePop();
-      }
-
-      if (ImGui::TreeNode("Capture/Logging"))
-      {
-         ImGui::TextWrapped("The logging API redirects all text output so you can easily capture the content of a window or a block. Tree nodes can be automatically expanded. You can also call ImGui::LogText() to output directly to the log without a visual output.");
-         ImGui::LogButtons();
-         ImGui::TreePop();
-      }
-   }
-
-   if (ImGui::CollapsingHeader("Widgets"))
-   {
-      if (ImGui::TreeNode("Basic"))
-      {
-         static int clicked = 0;
-         if (ImGui::Button("Button"))
+    // Exceptionally add an extra assert here for people confused about initial Dear ImGui setup
+    // Most ImGui functions would normally just crash if the context is missing.
+    IM_ASSERT(ImGui::GetCurrentContext() != NULL && "Missing dear imgui context. Refer to examples app!");
+
+    // Examples Apps (accessible from the "Examples" menu)
+    static bool show_app_main_menu_bar = false;
+    static bool show_app_documents = false;
+    static bool show_app_console = false;
+    static bool show_app_log = false;
+    static bool show_app_layout = false;
+    static bool show_app_property_editor = false;
+    static bool show_app_long_text = false;
+    static bool show_app_auto_resize = false;
+    static bool show_app_constrained_resize = false;
+    static bool show_app_simple_overlay = false;
+    static bool show_app_window_titles = false;
+    static bool show_app_custom_rendering = false;
+
+    if (show_app_main_menu_bar)       ShowExampleAppMainMenuBar();
+    if (show_app_documents)           ShowExampleAppDocuments(&show_app_documents);
+
+    if (show_app_console)             ShowExampleAppConsole(&show_app_console);
+    if (show_app_log)                 ShowExampleAppLog(&show_app_log);
+    if (show_app_layout)              ShowExampleAppLayout(&show_app_layout);
+    if (show_app_property_editor)     ShowExampleAppPropertyEditor(&show_app_property_editor);
+    if (show_app_long_text)           ShowExampleAppLongText(&show_app_long_text);
+    if (show_app_auto_resize)         ShowExampleAppAutoResize(&show_app_auto_resize);
+    if (show_app_constrained_resize)  ShowExampleAppConstrainedResize(&show_app_constrained_resize);
+    if (show_app_simple_overlay)      ShowExampleAppSimpleOverlay(&show_app_simple_overlay);
+    if (show_app_window_titles)       ShowExampleAppWindowTitles(&show_app_window_titles);
+    if (show_app_custom_rendering)    ShowExampleAppCustomRendering(&show_app_custom_rendering);
+
+    // Dear ImGui Apps (accessible from the "Tools" menu)
+    static bool show_app_metrics = false;
+    static bool show_app_style_editor = false;
+    static bool show_app_about = false;
+
+    if (show_app_metrics)       { ImGui::ShowMetricsWindow(&show_app_metrics); }
+    if (show_app_about)         { ImGui::ShowAboutWindow(&show_app_about); }
+    if (show_app_style_editor)
+    {
+        ImGui::Begin("Dear ImGui Style Editor", &show_app_style_editor);
+        ImGui::ShowStyleEditor();
+        ImGui::End();
+    }
+
+    // Demonstrate the various window flags. Typically you would just use the default!
+    static bool no_titlebar = false;
+    static bool no_scrollbar = false;
+    static bool no_menu = false;
+    static bool no_move = false;
+    static bool no_resize = false;
+    static bool no_collapse = false;
+    static bool no_close = false;
+    static bool no_nav = false;
+    static bool no_background = false;
+    static bool no_bring_to_front = false;
+
+    ImGuiWindowFlags window_flags = 0;
+    if (no_titlebar)        window_flags |= ImGuiWindowFlags_NoTitleBar;
+    if (no_scrollbar)       window_flags |= ImGuiWindowFlags_NoScrollbar;
+    if (!no_menu)           window_flags |= ImGuiWindowFlags_MenuBar;
+    if (no_move)            window_flags |= ImGuiWindowFlags_NoMove;
+    if (no_resize)          window_flags |= ImGuiWindowFlags_NoResize;
+    if (no_collapse)        window_flags |= ImGuiWindowFlags_NoCollapse;
+    if (no_nav)             window_flags |= ImGuiWindowFlags_NoNav;
+    if (no_background)      window_flags |= ImGuiWindowFlags_NoBackground;
+    if (no_bring_to_front)  window_flags |= ImGuiWindowFlags_NoBringToFrontOnFocus;
+    if (no_close)           p_open = NULL; // Don't pass our bool* to Begin
+
+    // We specify a default position/size in case there's no data in the .ini file.
+    // We only do it to make the demo applications a little more welcoming, but typically this isn't required.
+    ImGui::SetNextWindowPos(ImVec2(650, 20), ImGuiCond_FirstUseEver);
+    ImGui::SetNextWindowSize(ImVec2(550, 680), ImGuiCond_FirstUseEver);
+
+    // Main body of the Demo window starts here.
+    if (!ImGui::Begin("Dear ImGui Demo", p_open, window_flags))
+    {
+        // Early out if the window is collapsed, as an optimization.
+        ImGui::End();
+        return;
+    }
+
+    // Most "big" widgets share a common width settings by default. See 'Demo->Layout->Widgets Width' for details.
+
+    // e.g. Use 2/3 of the space for widgets and 1/3 for labels (default)
+    //ImGui::PushItemWidth(ImGui::GetWindowWidth() * 0.65f);
+
+    // e.g. Leave a fixed amount of width for labels (by passing a negative value), the rest goes to widgets.
+    ImGui::PushItemWidth(ImGui::GetFontSize() * -12);
+
+    // Menu Bar
+    if (ImGui::BeginMenuBar())
+    {
+        if (ImGui::BeginMenu("Menu"))
+        {
+            ShowExampleMenuFile();
+            ImGui::EndMenu();
+        }
+        if (ImGui::BeginMenu("Examples"))
+        {
+            ImGui::MenuItem("Main menu bar", NULL, &show_app_main_menu_bar);
+            ImGui::MenuItem("Console", NULL, &show_app_console);
+            ImGui::MenuItem("Log", NULL, &show_app_log);
+            ImGui::MenuItem("Simple layout", NULL, &show_app_layout);
+            ImGui::MenuItem("Property editor", NULL, &show_app_property_editor);
+            ImGui::MenuItem("Long text display", NULL, &show_app_long_text);
+            ImGui::MenuItem("Auto-resizing window", NULL, &show_app_auto_resize);
+            ImGui::MenuItem("Constrained-resizing window", NULL, &show_app_constrained_resize);
+            ImGui::MenuItem("Simple overlay", NULL, &show_app_simple_overlay);
+            ImGui::MenuItem("Manipulating window titles", NULL, &show_app_window_titles);
+            ImGui::MenuItem("Custom rendering", NULL, &show_app_custom_rendering);
+            ImGui::MenuItem("Documents", NULL, &show_app_documents);
+            ImGui::EndMenu();
+        }
+        if (ImGui::BeginMenu("Tools"))
+        {
+            ImGui::MenuItem("Metrics", NULL, &show_app_metrics);
+            ImGui::MenuItem("Style Editor", NULL, &show_app_style_editor);
+            ImGui::MenuItem("About Dear ImGui", NULL, &show_app_about);
+            ImGui::EndMenu();
+        }
+        ImGui::EndMenuBar();
+    }
+
+    ImGui::Text("dear imgui says hello. (%s)", IMGUI_VERSION);
+    ImGui::Spacing();
+
+    if (ImGui::CollapsingHeader("Help"))
+    {
+        ImGui::Text("ABOUT THIS DEMO:");
+        ImGui::BulletText("Sections below are demonstrating many aspects of the library.");
+        ImGui::BulletText("The \"Examples\" menu above leads to more demo contents.");
+        ImGui::BulletText("The \"Tools\" menu above gives access to: About Box, Style Editor,\n"
+                          "and Metrics (general purpose Dear ImGui debugging tool).");
+        ImGui::Separator();
+
+        ImGui::Text("PROGRAMMER GUIDE:");
+        ImGui::BulletText("See the ShowDemoWindow() code in imgui_demo.cpp. <- you are here!");
+        ImGui::BulletText("See comments in imgui.cpp.");
+        ImGui::BulletText("See example applications in the examples/ folder.");
+        ImGui::BulletText("Read the FAQ at http://www.dearimgui.org/faq/");
+        ImGui::BulletText("Set 'io.ConfigFlags |= NavEnableKeyboard' for keyboard controls.");
+        ImGui::BulletText("Set 'io.ConfigFlags |= NavEnableGamepad' for gamepad controls.");
+        ImGui::Separator();
+
+        ImGui::Text("USER GUIDE:");
+        ImGui::ShowUserGuide();
+    }
+
+    if (ImGui::CollapsingHeader("Configuration"))
+    {
+        ImGuiIO& io = ImGui::GetIO();
+
+        if (ImGui::TreeNode("Configuration##2"))
+        {
+            ImGui::CheckboxFlags("io.ConfigFlags: NavEnableKeyboard",    (unsigned int*)&io.ConfigFlags, ImGuiConfigFlags_NavEnableKeyboard);
+            ImGui::CheckboxFlags("io.ConfigFlags: NavEnableGamepad",     (unsigned int*)&io.ConfigFlags, ImGuiConfigFlags_NavEnableGamepad);
+            ImGui::SameLine(); HelpMarker("Required back-end to feed in gamepad inputs in io.NavInputs[] and set io.BackendFlags |= ImGuiBackendFlags_HasGamepad.\n\nRead instructions in imgui.cpp for details.");
+            ImGui::CheckboxFlags("io.ConfigFlags: NavEnableSetMousePos", (unsigned int*)&io.ConfigFlags, ImGuiConfigFlags_NavEnableSetMousePos);
+            ImGui::SameLine(); HelpMarker("Instruct navigation to move the mouse cursor. See comment for ImGuiConfigFlags_NavEnableSetMousePos.");
+            ImGui::CheckboxFlags("io.ConfigFlags: NoMouse",              (unsigned int*)&io.ConfigFlags, ImGuiConfigFlags_NoMouse);
+
+            // The "NoMouse" option above can get us stuck with a disable mouse! Provide an alternative way to fix it:
+            if (io.ConfigFlags & ImGuiConfigFlags_NoMouse)
+            {
+                if (fmodf((float)ImGui::GetTime(), 0.40f) < 0.20f)
+                {
+                    ImGui::SameLine();
+                    ImGui::Text("<<PRESS SPACE TO DISABLE>>");
+                }
+                if (ImGui::IsKeyPressed(ImGui::GetKeyIndex(ImGuiKey_Space)))
+                    io.ConfigFlags &= ~ImGuiConfigFlags_NoMouse;
+            }
+            ImGui::CheckboxFlags("io.ConfigFlags: NoMouseCursorChange", (unsigned int*)&io.ConfigFlags, ImGuiConfigFlags_NoMouseCursorChange);
+            ImGui::SameLine(); HelpMarker("Instruct back-end to not alter mouse cursor shape and visibility.");
+            ImGui::Checkbox("io.ConfigInputTextCursorBlink", &io.ConfigInputTextCursorBlink);
+            ImGui::SameLine(); HelpMarker("Set to false to disable blinking cursor, for users who consider it distracting");
+            ImGui::Checkbox("io.ConfigWindowsResizeFromEdges", &io.ConfigWindowsResizeFromEdges);
+            ImGui::SameLine(); HelpMarker("Enable resizing of windows from their edges and from the lower-left corner.\nThis requires (io.BackendFlags & ImGuiBackendFlags_HasMouseCursors) because it needs mouse cursor feedback.");
+            ImGui::Checkbox("io.ConfigWindowsMoveFromTitleBarOnly", &io.ConfigWindowsMoveFromTitleBarOnly);
+            ImGui::Checkbox("io.MouseDrawCursor", &io.MouseDrawCursor);
+            ImGui::SameLine(); HelpMarker("Instruct Dear ImGui to render a mouse cursor itself. Note that a mouse cursor rendered via your application GPU rendering path will feel more laggy than hardware cursor, but will be more in sync with your other visuals.\n\nSome desktop applications may use both kinds of cursors (e.g. enable software cursor only when resizing/dragging something).");
+            ImGui::Text("Also see Style->Rendering for rendering options.");
+            ImGui::TreePop();
+            ImGui::Separator();
+        }
+
+        if (ImGui::TreeNode("Backend Flags"))
+        {
+            HelpMarker(
+                "Those flags are set by the back-ends (imgui_impl_xxx files) to specify their capabilities.\n"
+                "Here we expose then as read-only fields to avoid breaking interactions with your back-end.");
+
+            // Make a local copy to avoid modifying actual back-end flags.
+            ImGuiBackendFlags backend_flags = io.BackendFlags;
+            ImGui::CheckboxFlags("io.BackendFlags: HasGamepad",           (unsigned int*)&backend_flags, ImGuiBackendFlags_HasGamepad);
+            ImGui::CheckboxFlags("io.BackendFlags: HasMouseCursors",      (unsigned int*)&backend_flags, ImGuiBackendFlags_HasMouseCursors);
+            ImGui::CheckboxFlags("io.BackendFlags: HasSetMousePos",       (unsigned int*)&backend_flags, ImGuiBackendFlags_HasSetMousePos);
+            ImGui::CheckboxFlags("io.BackendFlags: RendererHasVtxOffset", (unsigned int*)&backend_flags, ImGuiBackendFlags_RendererHasVtxOffset);
+            ImGui::TreePop();
+            ImGui::Separator();
+        }
+
+        if (ImGui::TreeNode("Style"))
+        {
+            HelpMarker("The same contents can be accessed in 'Tools->Style Editor' or by calling the ShowStyleEditor() function.");
+            ImGui::ShowStyleEditor();
+            ImGui::TreePop();
+            ImGui::Separator();
+        }
+
+        if (ImGui::TreeNode("Capture/Logging"))
+        {
+            HelpMarker(
+                "The logging API redirects all text output so you can easily capture the content of "
+                "a window or a block. Tree nodes can be automatically expanded.\n"
+                "Try opening any of the contents below in this window and then click one of the \"Log To\" button.");
+            ImGui::LogButtons();
+
+            HelpMarker("You can also call ImGui::LogText() to output directly to the log without a visual output.");
+            if (ImGui::Button("Copy \"Hello, world!\" to clipboard"))
+            {
+                ImGui::LogToClipboard();
+                ImGui::LogText("Hello, world!");
+                ImGui::LogFinish();
+            }
+            ImGui::TreePop();
+        }
+    }
+
+    if (ImGui::CollapsingHeader("Window options"))
+    {
+        ImGui::Checkbox("No titlebar", &no_titlebar); ImGui::SameLine(150);
+        ImGui::Checkbox("No scrollbar", &no_scrollbar); ImGui::SameLine(300);
+        ImGui::Checkbox("No menu", &no_menu);
+        ImGui::Checkbox("No move", &no_move); ImGui::SameLine(150);
+        ImGui::Checkbox("No resize", &no_resize); ImGui::SameLine(300);
+        ImGui::Checkbox("No collapse", &no_collapse);
+        ImGui::Checkbox("No close", &no_close); ImGui::SameLine(150);
+        ImGui::Checkbox("No nav", &no_nav); ImGui::SameLine(300);
+        ImGui::Checkbox("No background", &no_background);
+        ImGui::Checkbox("No bring to front", &no_bring_to_front);
+    }
+
+    // All demo contents
+    ShowDemoWindowWidgets();
+    ShowDemoWindowLayout();
+    ShowDemoWindowPopups();
+    ShowDemoWindowColumns();
+    ShowDemoWindowMisc();
+
+    // End of ShowDemoWindow()
+    ImGui::End();
+}
+
+static void ShowDemoWindowWidgets()
+{
+    if (!ImGui::CollapsingHeader("Widgets"))
+        return;
+
+    if (ImGui::TreeNode("Basic"))
+    {
+        static int clicked = 0;
+        if (ImGui::Button("Button"))
             clicked++;
-         if (clicked & 1)
-         {
+        if (clicked & 1)
+        {
             ImGui::SameLine();
             ImGui::Text("Thanks for clicking me!");
-         }
-
-         static bool check = true;
-         ImGui::Checkbox("checkbox", &check);
-
-         static int e = 0;
-         ImGui::RadioButton("radio a", &e, 0); ImGui::SameLine();
-         ImGui::RadioButton("radio b", &e, 1); ImGui::SameLine();
-         ImGui::RadioButton("radio c", &e, 2);
-
-         // Color buttons, demonstrate using PushID() to add unique identifier in the ID stack, and changing style.
-         for (int i = 0; i < 7; i++)
-         {
-            if (i > 0) ImGui::SameLine();
+        }
+
+        static bool check = true;
+        ImGui::Checkbox("checkbox", &check);
+
+        static int e = 0;
+        ImGui::RadioButton("radio a", &e, 0); ImGui::SameLine();
+        ImGui::RadioButton("radio b", &e, 1); ImGui::SameLine();
+        ImGui::RadioButton("radio c", &e, 2);
+
+        // Color buttons, demonstrate using PushID() to add unique identifier in the ID stack, and changing style.
+        for (int i = 0; i < 7; i++)
+        {
+            if (i > 0)
+                ImGui::SameLine();
             ImGui::PushID(i);
             ImGui::PushStyleColor(ImGuiCol_Button, (ImVec4)ImColor::HSV(i / 7.0f, 0.6f, 0.6f));
@@ -299,20 +516,32 @@
             ImGui::PopStyleColor(3);
             ImGui::PopID();
-         }
-
-         // Arrow buttons
-         float spacing = ImGui::GetStyle().ItemInnerSpacing.x;
-         if (ImGui::ArrowButton("##left", ImGuiDir_Left)) {}
-         ImGui::SameLine(0.0f, spacing);
-         if (ImGui::ArrowButton("##left", ImGuiDir_Right)) {}
-
-         ImGui::Text("Hover over me");
-         if (ImGui::IsItemHovered())
+        }
+
+        // Use AlignTextToFramePadding() to align text baseline to the baseline of framed widgets elements
+        // (otherwise a Text+SameLine+Button sequence will have the text a little too high by default!)
+        // See 'Demo->Layout->Text Baseline Alignment' for details.
+        ImGui::AlignTextToFramePadding();
+        ImGui::Text("Hold to repeat:");
+        ImGui::SameLine();
+
+        // Arrow buttons with Repeater
+        static int counter = 0;
+        float spacing = ImGui::GetStyle().ItemInnerSpacing.x;
+        ImGui::PushButtonRepeat(true);
+        if (ImGui::ArrowButton("##left", ImGuiDir_Left)) { counter--; }
+        ImGui::SameLine(0.0f, spacing);
+        if (ImGui::ArrowButton("##right", ImGuiDir_Right)) { counter++; }
+        ImGui::PopButtonRepeat();
+        ImGui::SameLine();
+        ImGui::Text("%d", counter);
+
+        ImGui::Text("Hover over me");
+        if (ImGui::IsItemHovered())
             ImGui::SetTooltip("I am a tooltip");
 
-         ImGui::SameLine();
-         ImGui::Text("- or me");
-         if (ImGui::IsItemHovered())
-         {
+        ImGui::SameLine();
+        ImGui::Text("- or me");
+        if (ImGui::IsItemHovered())
+        {
             ImGui::BeginTooltip();
             ImGui::Text("I am a fancy tooltip");
